%define major                   7
%define libname                 %mklibname preludedb %{major}
%define cppmajor                2
%define libcpp                  %mklibname preludedbcpp %{cppmajor}
%define libnamedevel            %mklibname preludedb -d

Name:           libpreludedb
Version:        5.2.0
Release:        %mkrel 1
Summary:        Provide the framework for easy access to the Prelude database
License:        GPLv2+
Group:          System/Libraries
URL:            https://www.prelude-siem.org/
Source0:        https://www.prelude-siem.org/pkg/src/%{version}/%{name}-%{version}.tar.gz
Source4:        libpreludedb-addIndices.sql
Patch0:         libpreludedb-1.2.6-cpp-lib.patch
Patch2:         gtk-doc.patch
Patch10:        python3.8.patch
BuildRequires:  bison
BuildRequires:  chrpath
BuildRequires:  flex
BuildRequires:  gtk-doc
BuildRequires:  multiarch-utils
BuildRequires:  swig
BuildRequires:  mysql-devel
BuildRequires:  perl-devel
BuildRequires:  postgresql-devel
BuildRequires:  pkgconfig(gnutls)
BuildRequires:  pkgconfig(libprelude) >= %{version}
BuildRequires:  pkgconfig(openssl)
BuildRequires:  pkgconfig(python3)
BuildRequires:  pkgconfig(sqlite3)
BuildRequires:  pkgconfig(zlib)

%description
The PreludeDB Library provides an abstraction layer upon the type
and the format of the database used to store IDMEF alerts. It
allows developers to use the Prelude IDMEF database easily and
efficiently without worrying about SQL, and to access the
database independently of the type/format of the database.

%package -n %{libname}
Summary:        Provide the framework for easy access to the Prelude database
Group:          System/Libraries
Provides:       %{name} = %{version}-%{release}

%description -n %{libname}
The PreludeDB Library provides an abstraction layer upon the type
and the format of the database used to store IDMEF alerts. It
allows developers to use the Prelude IDMEF database easily and
efficiently without worrying about SQL, and to access the
database independently of the type/format of the database.

%package -n %{libcpp}
Summary:        Provide the framework for easy access to the Prelude database
Group:          System/Libraries

%description -n %{libcpp}
The PreludeDB Library provides an abstraction layer upon the type
and the format of the database used to store IDMEF alerts. It
allows developers to use the Prelude IDMEF database easily and
efficiently without worrying about SQL, and to access the
database independently of the type/format of the database.

%package -n %{libnamedevel}
Summary:        Libraries and headers for PreludeDB
Group:          Development/C
Requires:       %{libname} = %{version}-%{release}
Requires:       %{libcpp} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Provides:       preludedb-devel = %{version}-%{release}
Obsoletes:      %{mklibname -d preludedb 0}

%description -n %{libnamedevel}
The PreludeDB Library provides an abstraction layer upon the type
and the format of the database used to store IDMEF alerts. It
allows developers to use the Prelude IDMEF database easily and
efficiently without worrying about SQL, and to access the
database independently of the type/format of the database.

This package contains the development libraries and headers for
PreludeDB.

%package -n preludedb-tools
Summary:        The interface for %{libname}
Group:          Networking/Other
Requires:       %{libname} = %{version}-%{release}

%description -n preludedb-tools
Provides a convenient interface for sending alerts to Prelude
Manager.

%package -n python3-preludedb
Summary:        Python 3 bindings for PreludeDB
Group:          Development/Python
Requires:       %{libname} = %{version}-%{release}
%{?python_provide:%python_provide python3-preludedb}

%description -n python3-preludedb
Provides python 3 bindings for PreludeDB.

%package -n perl-preludedb
Summary:        Perl bindings for PreludeDB
Group:          Development/Perl
Requires:       %{libname} = %{version}-%{release}

%description -n perl-preludedb
Provides perl bindings for PreludeDB.

%package -n preludedb-mysql
Summary:        Plugin to use prelude with a MySQL database
Group:          System/Servers
Requires:       %{libname} = %{version}-%{release}
Obsoletes:      prelude-manager-mysql-plugin < %{version}-%{release}
Provides:       prelude-manager-mysql-plugin = %{version}-%{release}

%description -n preludedb-mysql
This plugin authorise prelude to store alerts into a MySQL
database.

%package -n preludedb-pgsql
Summary:        Plugin to use prelude with a PostgreSQL database
Group:          System/Servers
Requires:       %{libname} = %{version}-%{release}
Obsoletes:      prelude-manager-pgsql-plugin < %{version}-%{release}
Provides:       prelude-manager-pgsql-plugin = %{version}-%{release}

%description -n preludedb-pgsql
This plugin authorise prelude to store alerts into a PostgreSQL
database.

%package -n preludedb-sqlite3
Summary:        Plugin to use prelude with a SQLite3 database
Group:          System/Servers
Requires:       %{libname} = %{version}-%{release}

%description -n preludedb-sqlite3
This plugin authorise prelude to store alerts into a SQLite3
database.

%prep
%setup -q
rm -f bindings/python/*.cxx
%autopatch -p1

%build
autoreconf -vfi
%configure \
    --disable-rpath \
    --disable-static \
    --enable-shared \
    --localstatedir=%{_var} \
    --includedir=%{_includedir}/%{name} \
    --with-swig \
    --without-python2 \
    --with-python3 \
    --enable-gtk-doc \
    --with-html-dir=%{_docdir}/%{libnamedevel}
%make_build

%install
%make_install

find %{buildroot} -name '*.la' -delete

%{__cp} -a %{SOURCE4} %{buildroot}%{_datadir}/%{name}/classic/addIndices.sql

# python shebangs
pathfix.py -pni "%{__python3} %{py3_shbang_opts}" %{buildroot}%{_bindir}/preludedb-admin

%files -n %{libname}
%doc ChangeLog NEWS README
%license COPYING HACKING.README LICENSE.README
%{_libdir}/%{name}.so.%{major}
%{_libdir}/%{name}.so.%{major}.*
%dir %{_libdir}/%{name}/
%dir %{_libdir}/%{name}/plugins
%dir %{_libdir}/%{name}/plugins/formats
%dir %{_libdir}/%{name}/plugins/sql
%{_libdir}/%{name}/plugins/formats/classic.so

%files -n %{libcpp}
%{_libdir}/%{name}cpp.so.%{cppmajor}
%{_libdir}/%{name}cpp.so.%{cppmajor}.*

%files -n %{libnamedevel}
%doc %{_docdir}/%{libnamedevel}
%{_bindir}/%{name}-config
%{_libdir}/*.so
%{_includedir}/%{name}/
%{_datadir}/aclocal/*.m4
%{_mandir}/man1/%{name}-config.1*

%files -n preludedb-tools
%{_bindir}/preludedb-admin
%{_mandir}/man1/preludedb-admin.1*

%files -n python3-preludedb
%{python3_sitearch}/*

%files -n preludedb-mysql
%{_libdir}/%{name}/plugins/sql/mysql.so
%attr(0755,root,root) %{_datadir}/%{name}/classic/mysql2sqlite.sh
%attr(0755,root,root) %{_datadir}/%{name}/classic/mysql2pgsql.sh
%{_datadir}/%{name}/classic/*.sql
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/classic

%files -n preludedb-pgsql
%{_libdir}/%{name}/plugins/sql/pgsql.so
%{_datadir}/%{name}/classic/pgsql*
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/classic

%files -n preludedb-sqlite3
%{_libdir}/%{name}/plugins/sql/sqlite3.so
%{_datadir}/%{name}/classic/sqlite*
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/classic


%changelog
* Fri Sep 18 2020 daviddavid <daviddavid> 5.2.0-1.mga8
+ Revision: 1628533
- new version: 5.2.0

* Mon Feb 17 2020 daviddavid <daviddavid> 5.1.0-3.mga8
+ Revision: 1537448
- fix python shebangs
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Tue Oct 29 2019 daviddavid <daviddavid> 5.1.0-2.mga8
+ Revision: 1456479
- rebuild for new libprelude 5.1.1

* Sun Oct 20 2019 daviddavid <daviddavid> 5.1.0-1.mga8
+ Revision: 1454761
- new version: 5.1.0
- remove merged upstream patch

* Wed Sep 11 2019 wally <wally> 5.0.0-2.mga8
+ Revision: 1439643
- rebuild for python3.8
- drop python2 support
- fix build with gtk-doc >= 1.32

* Sun Feb 24 2019 daviddavid <daviddavid> 5.0.0-1.mga7
+ Revision: 1369817
- new version: 5.0.0

* Tue Jan 08 2019 daviddavid <daviddavid> 4.1.0-3.mga7
+ Revision: 1352423
- rebuild for new Python 3.7

* Sun Sep 23 2018 umeabot <umeabot> 4.1.0-2.mga7
+ Revision: 1299099
- Mageia 7 Mass Rebuild

* Sat Jan 13 2018 daviddavid <daviddavid> 4.1.0-1.mga7
+ Revision: 1192636
- new version: 4.1.0
- remove merged upstream patch (fix-gtk-doc)

* Sat Dec 23 2017 wally <wally> 4.0.0-4.mga7
+ Revision: 1184224
- rebuild for new mariadb

* Sat Dec 23 2017 daviddavid <daviddavid> 4.0.0-3.mga7
+ Revision: 1184165
- rebuild for new mariadb

* Fri Nov 03 2017 daviddavid <daviddavid> 4.0.0-2.mga7
+ Revision: 1175631
- add fedora patch to fix build with gtk-doc 1.26

* Sat Sep 23 2017 daviddavid <daviddavid> 4.0.0-1.mga7
+ Revision: 1157805
- new version: 4.0.0
- update Summary and description
- rename python-preludedb to python2-preludedb

* Fri Aug 04 2017 daviddavid <daviddavid> 3.1.0-2.mga7
+ Revision: 1134855
- rebuild for Python 3.6

* Sat Oct 15 2016 daviddavid <daviddavid> 3.1.0-1.mga6
+ Revision: 1060910
- new version: 3.1.0 (mga#19451)
- update BRs list
- fix some ownership dir

* Fri Feb 26 2016 fwang <fwang> 1.2.6-2.mga6
+ Revision: 979370
- force regenerate cxx file
+ tv <tv>
- rebuild for python 3.5

* Fri Sep 11 2015 fwang <fwang> 1.2.6-1.mga6
+ Revision: 876893
- update file list
- update file list
- link against libpreludecpp
- fix br
- bump req
- 1.2.6

* Sat Jun 27 2015 tv <tv> 1.0.1p1-16.mga6
+ Revision: 846148
- rebuild with soname-ified perl

* Wed Jun 24 2015 sander85 <sander85> 1.0.1p1-15.mga6
+ Revision: 841777
- Rebuild for perl 5.22

* Tue Nov 25 2014 cjw <cjw> 1.0.1p1-14.mga5
+ Revision: 798935
- rebuild against postgresql9.4

* Wed Oct 15 2014 umeabot <umeabot> 1.0.1p1-13.mga5
+ Revision: 740041
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 1.0.1p1-12.mga5
+ Revision: 726841
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 1.0.1p1-11.mga5
+ Revision: 681719
- Mageia 5 Mass Rebuild

* Sat Jul 05 2014 pterjan <pterjan> 1.0.1p1-10.mga5
+ Revision: 643926
- Fix build with perl 5.20
- Rebuild for perl 5.20
+ jquelin <jquelin>
- perl 5.20.0 rebuild

* Sat May 31 2014 pterjan <pterjan> 1.0.1p1-7.mga5
+ Revision: 628305
- Rebuild for new Python

* Tue Oct 22 2013 umeabot <umeabot> 1.0.1p1-6.mga4
+ Revision: 542753
- Mageia 4 Mass Rebuild

* Mon Oct 14 2013 pterjan <pterjan> 1.0.1p1-5.mga4
+ Revision: 497869
- Rebuild to add different pythonegg provides for python 2 and 3

* Wed May 29 2013 fwang <fwang> 1.0.1p1-4.mga4
+ Revision: 430417
- rebuild for new perl

* Sat Jan 12 2013 umeabot <umeabot> 1.0.1p1-3.mga3
+ Revision: 357996
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Sep 03 2012 fwang <fwang> 1.0.1p1-2.mga3
+ Revision: 287453
- force reconf

* Mon Sep 03 2012 fwang <fwang> 1.0.1p1-1.mga3
+ Revision: 287448
- fix build with glibc
- new version 1.0.1p1

* Wed May 30 2012 jquelin <jquelin> 1.0.0-9.mga3
+ Revision: 251645
- perl 5.16 rebuild

* Tue Aug 02 2011 fwang <fwang> 1.0.0-8.mga2
+ Revision: 131427
- drop .la files

* Sun Jun 12 2011 ahmad <ahmad> 1.0.0-7.mga2
+ Revision: 104586
- Rebuild for perl-5.14.0

* Thu Mar 24 2011 dmorgan <dmorgan> 1.0.0-6.mga1
+ Revision: 77059
- Rebuild against new mysql

* Sun Mar 06 2011 ennael <ennael> 1.0.0-5.mga1
+ Revision: 65669
- clean spec file
- clean spec file
- imported package libpreludedb


* Sat Jan 01 2011 Oden Eriksson <oeriksson@mandriva.com> 1.0.0-5mdv2011.0
+ Revision: 627000
- rebuilt against mysql-5.5.8 libs, again

* Mon Dec 27 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.0-4mdv2011.0
+ Revision: 625421
- rebuilt against mysql-5.5.8 libs

* Mon Nov 01 2010 Funda Wang <fwang@mandriva.org> 1.0.0-3mdv2011.0
+ Revision: 591329
- rebuild for py 2.7

* Sun Aug 01 2010 Funda Wang <fwang@mandriva.org> 1.0.0-2mdv2011.0
+ Revision: 564325
- rebuild for perl 5.12.1

* Sun Apr 25 2010 Funda Wang <fwang@mandriva.org> 1.0.0-1mdv2010.1
+ Revision: 538657
- New version 1.0.0
- disable static libs

* Wed Feb 17 2010 Oden Eriksson <oeriksson@mandriva.com> 0.9.15.1-6mdv2010.1
+ Revision: 507032
- rebuild

* Wed Sep 02 2009 Christophe Fergeau <cfergeau@mandriva.com> 0.9.15.1-5mdv2010.0
+ Revision: 425691
- rebuild

* Sat Dec 27 2008 Funda Wang <fwang@mandriva.org> 0.9.15.1-4mdv2009.1
+ Revision: 319811
- fix str fmt

  + Oden Eriksson <oeriksson@mandriva.com>
    - use lowercase mysql-devel

* Sat Dec 06 2008 Oden Eriksson <oeriksson@mandriva.com> 0.9.15.1-3mdv2009.1
+ Revision: 311201
- rebuilt against mysql-5.1.30 libs

* Fri Oct 17 2008 Funda Wang <fwang@mandriva.org> 0.9.15.1-2mdv2009.1
+ Revision: 294712
- rebuild for package loss

* Sun Oct 12 2008 Funda Wang <fwang@mandriva.org> 0.9.15.1-1mdv2009.1
+ Revision: 292806
- New version 0.9.15.1

* Thu Aug 28 2008 Funda Wang <fwang@mandriva.org> 0.9.15-1mdv2009.0
+ Revision: 276781
- add missing file
- New version 0.9.15

* Sat Jun 28 2008 Oden Eriksson <oeriksson@mandriva.com> 0.9.14.1-5mdv2009.0
+ Revision: 229889
- drop the pgsql headers patch

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Mon Jan 21 2008 Thierry Vignaud <tv@mandriva.org> 0.9.14.1-3mdv2008.1
+ Revision: 155663
- rebuild for new perl

* Mon Jan 21 2008 Funda Wang <fwang@mandriva.org> 0.9.14.1-2mdv2008.1
+ Revision: 155599
- rebuild against latest gnutls

* Fri Jan 04 2008 Jérôme Soyer <saispo@mandriva.org> 0.9.14.1-1mdv2008.1
+ Revision: 144990
- New release

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Sep 05 2007 Funda Wang <fwang@mandriva.org> 0.9.13-3mdv2008.0
+ Revision: 80181
- fix BR
- obsoletes old devel package

* Mon Aug 20 2007 David Walluck <walluck@mandriva.org> 0.9.13-2mdv2008.0
+ Revision: 68089
- fix some typos
- fix html-dir

* Mon Aug 20 2007 David Walluck <walluck@mandriva.org> 0.9.13-1mdv2008.0
+ Revision: 68081
- regenerate configure in %%prep
- 0.9.13
- new lib policy
- add static lib package
- remove numeric_to_bigint patch (fixed upstream)
- no need to regenerate configure
- more strict directory permissions
- move %%{_datadir}/%%{name}/classic out of lib package (still does not fix multi-owership problem)
- change html-dir from %%{_datadir}/doc/%%{name}-devel-%%{version} to %%{_docdir}/%%{name}-devel (still not ideal)

* Tue Aug 07 2007 David Walluck <walluck@mandriva.org> 0.9.12-1mdv2008.0
+ Revision: 59751
- 0.9.12

* Wed May 16 2007 David Walluck <walluck@mandriva.org> 0.9.11.3-3mdv2008.0
+ Revision: 27258
- add patch from <https://trac.prelude-ids.org/ticket/225>

* Sat May 12 2007 David Walluck <walluck@mandriva.org> 0.9.11.3-2mdv2008.0
+ Revision: 26470
- add additional SQL file


* Fri Feb 09 2007 David Walluck <walluck@mandriva.org> 0.9.11.3-1mdv2007.0
+ Revision: 118271
- 0.9.11.3

* Sun Jan 07 2007 David Walluck <walluck@mandriva.org> 0.9.11.1-1mdv2007.1
+ Revision: 105075
- 0.9.11.1

* Thu Dec 21 2006 David Walluck <walluck@mandriva.org> 0.9.11-2mdv2007.1
+ Revision: 100901
- fix some macros

* Thu Dec 21 2006 David Walluck <walluck@mandriva.org> 0.9.11-1mdv2007.1
+ Revision: 100893
- 9.11-1

* Thu Oct 19 2006 David Walluck <walluck@mandriva.org> 0.9.10-2mdv2007.0
+ Revision: 71044
- fix build
- 0.9.10
- Import libpreludedb

* Tue Sep 05 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.8.1-1mdv2007.0
- rebuilt against MySQL-5.0.24a-1mdv2007.0 due to ABI changes

* Tue Jul 11 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.8.1-1mdv2007.0
- 0.9.8.1

* Fri Jun 16 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.8-1mdv2007.0
- 0.9.8 (Major bugfixes)

* Fri Mar 31 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.7.1-1mdk
- 0.9.7.1 (Minor bugfixes)

* Thu Mar 09 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.6-1mdk
- 0.9.6 (Minor bugfixes)
- rediffed P0

* Mon Mar 06 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.5.1-1mdk
- 0.9.5.1

* Wed Feb 22 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.5-1mdk
- 0.9.5 (Major bugfixes)
- added P0 to make it find the postgresql headers

* Wed Feb 08 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.4-1mdk
- 0.9.4 (Major bugfixes)

* Mon Jan 16 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.3-1mdk
- 0.9.3
- added the sqlite sub package
- fix autofoo

* Tue Jan 10 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.2-1mdk
- initial Mandriva package

